#include <stdio.h>
#include <stdlib.h>

/*  Tablas LaTeX sealando los primos */


#define NPRIM 1000
unsigned int primo[NPRIM]={2,3};

int esprimo(int n){
	int i=0;
	if ( n==1) return 0;
	while( primo[i]*primo[i]<=n )
		if( (n % primo[i++])==0 ) return 0;
	return 1;	
}

void listaprimos(void){
	int i;
	for(i=2;i<NPRIM; ++i){
		primo[i]=primo[i-1]+2;
		while( !esprimo(primo[i]) ) primo[i]+=2;
	}
}


void imprimelistaprimos(void){
	int i;
	listaprimos();
	for(i=0;i<NPRIM;++i)
		printf("p[%d]=%d\n",i,primo[i]);
}


void tabla( int fil, int col){
	int i,j,n;
	/* Cabecera */
	printf("\n\n\\begin{center}\n\\color{Gris}\n\\begin{tabular}{");
	for(i=0;i<col;++i) printf("c");
        printf("}\n");

	/* Recorre filas */
	for(i=0; i<fil;++i){
		/* Una fila */
		for( j=0;j<col;++j){
			n=col*i+j+1;
			if( esprimo(n) ) printf("{\\color{black}\\bf ");
//			if( esprimo(n)&& ((j==0)) ) printf("\\alert{");
//			if( esprimo(n)&& ((j==0)||(j==1)||(j==3)) ) printf("\\alert{");
			printf("%d ",n);
//			if( esprimo(n)&& ((j==0)) ) printf("}");
			if( esprimo(n) ) printf("}");
			if( j!=col-1 ) printf("&");
		}
		printf("\n");
		if( i!=fil-1 ) printf("\\\\\n");
	}

	printf("\\end{tabular}\n\\end{center}\n\n");

}


int main(int argc, char *argv[]){
	listaprimos();
	tabla(19,4);
}
